#include <FlashAsEEPROM.h>
#include <FlashStorage.h>
  typedef struct{
    bool valid;
    uint32_t STOP_TimerCounter_tresh; 
    uint32_t STOP_TimerTurnOff_tresh; 
    uint32_t HaltTimerTresh;    
    uint16_t CRC;
  }PersistenParams_t;

FlashStorage(PersistentTimers, PersistenParams_t);  
PersistenParams_t DYFAM_Timers;

/*
 * Relative moked function. 
 * Inits the timers (or the persistent data, generally speaking)structure
*/
int32_t Mem_init(void){
    DYFAM_Timers = PersistentTimers.read();
    if(true != DYFAM_Timers.valid){
#ifdef DEBUG_PRINT    
      Serial.print("STOP_TimerCounter_tresh ");Serial.println(DYFAM_Timers.STOP_TimerCounter_tresh);
      Serial.print("STOP_TimerTurnOff_tresh ");Serial.println(DYFAM_Timers.STOP_TimerTurnOff_tresh);
      Serial.print("HaltTimerTresh ");Serial.println(DYFAM_Timers.HaltTimerTresh);
#endif
      DYFAM_Timers.STOP_TimerCounter_tresh = 120;
      DYFAM_Timers.STOP_TimerTurnOff_tresh = 10;
      DYFAM_Timers.HaltTimerTresh = 120;
      DYFAM_Timers.valid = true; 
      PersistentTimers.write(DYFAM_Timers);
    }else{
      Serial.print("STOP_TimerCounter_tresh");Serial.println(DYFAM_Timers.STOP_TimerCounter_tresh);
      Serial.print("STOP_TimerTurnOff_tresh");Serial.println(DYFAM_Timers.STOP_TimerTurnOff_tresh);
      Serial.print("HaltTimerTresh");Serial.println(DYFAM_Timers.HaltTimerTresh);
    }
}

/* 
 *  @brief: updates the persistent memory from the config state. 
 *          
 *  TODO: Check usage here.
*/
int32_t Mem_Update(int32_t par1, int32_t par2,int32_t par3){
      DYFAM_Timers.STOP_TimerCounter_tresh = par1;
      DYFAM_Timers.STOP_TimerTurnOff_tresh = par2;
      DYFAM_Timers.HaltTimerTresh = par3;
      DYFAM_Timers.valid = true; 
      PersistentTimers.write(DYFAM_Timers);
      return 0;
}

uint16_t calcCRC(uint8_t pData, size_t sectSize){
  /* TODO: CALC CRC16*/
  return 0;
}
/* 
 *  @brief: evaluate the CRC of the flash storage. 
 *  @return: true if CRC stored in memory is valid.
*/
bool Mem_checkCRC(void){
  //if(DYFAM_Timers.CRC = calcCRC(void, 0))
  return true; 
}


