#include "src\StateMachine\single\TRSSyncSingleReceptor.h"

void SM_DRIVING_OnEnter(void){
  Serial.println("STATE: Driving_onEnter");
}

void SM_DRIVING_OnExit(void){
  Serial.println("Driving exit");
  }

int32_t SM_DRIVING(TokenizerSyncSingleReceptor_t *pMsg){
  Serial.println("STATE: Driving");
  if(!pMsg->is_moving){
      pMsg->stateID = STATE_HALT; /* Fermata  */
  }else{
    pMsg->stateID = STATE_DRIVING;
  }
}
