#include "src\StateMachine\single\TRSSyncSingleReceptor.h"

void SM_POST_OnEnter(void){
    //Serial.println("On POST enter");
}

void SM_POST_OnExit(void){
  Serial.println("On POST exit");
}
FlashStorage(age_storage, int);
/*
 * Power On Self Test. 
 * Checks for ADAFRUIT components to be plugged and working fine. 
 * 
*/
int32_t SM_POST(TokenizerSyncSingleReceptor_t *pMsg){
  Serial.begin(115200);
  Serial.println("PostMain");
#ifdef DEBUG_PRINT    
  Serial.println("press a key to proceed");
  while(Serial.available() <1);
#endif
  /* Init BLE */
  if ( !ble.begin(VERBOSE_MODE) )
  {
    error(F("Couldn't find Bluefruit, make sure it's in CoMmanD mode & check wiring?"));
  }

  if ( ! ble.factoryReset() ){
      error(F("Couldn't factory reset"));
      while(1);
    }
  Serial.println("BLueFriend found!");
  ble.echo(false);
  
  /* Init accelerometer */
    if (! mma.begin()) {
    Serial.println("Couldnt start MMA8451");
    while (1);
  }
  Serial.println("MMA8451 found!");
  /* Init Sigfox*/
  SigFox.debug();
  if (! SigFox.begin()) {
    Serial.println("Couldnt start SIGFOX Module");
    while(1);
  }
  delay(100);
  Serial.println("SIGFOX Module found!");

  Mem_init();
  if(true != Mem_checkCRC()){
    pMsg->stateID = STATE_CONF_MISS;
  }else{
    pMsg->stateID = STATE_INIT;
  }
}

