/**
 * MainSM.h
 * @brief 
 * @date   9 Oct 2017
 * @author Luca Toso
 * 
 * 
 * Modified by: $Author:$
 * 				$Revision:$
 * 				$Date:$
 */

/**
 * @addtogroup
 * @{
 */



#ifndef STATEMACHINE_SINGLE_MAINSM_H_
#define STATEMACHINE_SINGLE_MAINSM_H_


/****************************** SYSTEM INCLUDES *******************************/

/******************************* PROJECT INCLUDES *****************************/
#include "../SystemDefs.h"
#include "TokenizeAsyncSinglePKG.h"
#include "TRSSyncSingleReceptor.h"
#include "TSREventQueue.h"
#include "MainSM.h"

/************************* TYPEDEFS, STRUCTURES and UNIONS ********************/
/************************ MACRO AND CONST DEFINITION **************************/
/************************** EXPOSED FUNCTION PROTOTYPES ***********************/
void TokenizerAsyncSingleReceptor_TurnOnEngine(void);
TokenizerSyncSingleReceptor_t *TokenizerAsyncSingleReceptor_Create(void);
void TokenizerAsyncSingleReceptor_taskLoop(void);
int32_t getValuesFromDevices(TokenizerSyncSingleReceptor_t *pMsg);

#endif /* STATEMACHINE_SINGLE_MAINSM_H_ */
/** @}*/
/******************************** END OF FILE *********************************/
